#!/usr/bin/perl

# A configuration file

# the pmars command
$PMARS=`which pmars`;
chomp($PMARS);

# where to get names for the warriors
$DICT="/usr/lib/games/hangman-words";

# size of field (a square, e.g. 100 is 100x100 square)
$SIZE=80;

# how many fights per battle
$FIGHTS=100;

# warrior data
$WARSIZE=20;
$WARCORESIZE=800;
$WARLOCALCHANCE=75; # in %
$MUTATIONCHANCE=3; # in % (an instruction changes) 
$SIZECHANGECHANCE=3; # in % (instruction deleted/added)

$SCORELAST=10; #count score as the average of last x fights

# backup warriors to disk every x runs
$BACKUPFREQ=3000;

# default env
$DEFENV='-@ 94t.opt';

# chance the size of one of the corners will change
$CORNERCH=100;
# by how much should be changed (1-x)
$CORNERST=5;

# four corners have different enviroments and can change in size
$NWENV='-@ 94t.opt -p 8';
$NWMAX=30;
$NWMIN=8;
$NWCUR=15;

$NEENV='-@ 94t.opt -c 2000';
$NEMAX=30;
$NEMIN=8;
$NECUR=15;

$SWENV='-@ 94t.opt -p 1';
$SWMAX=30;
$SWMIN=8;
$SWCUR=15;

$SEENV='-@ 94t.opt -p 1 -c 2000';
$SEMAX=30;
$SEMIN=8;
$SECUR=15;

# the opcodes used
@opcodes=('DAT','MOV','ADD','SUB','MUL','DIV','MOD','JMP','JMZ','JMN','DJN','CMP','SLT','SPL','LDP','STP');
@modifiers=('A','B','AB','BA','F','X','I');
@modes=('#','$','@','*','<','>','{','}');

